#!/bin/sh

os=`uname`
cd /quadstor/pgsqlsys/
PGPORT=9984; export PGPORT
bindir=`pg_config | grep BINDIR | cut -f 3 -d ' '`
if [ "$bindir" = "" ]; then
  echo "failed to get postgresql bin directory"
  exit 1
fi
$bindir/initdb -D /quadstor/pgsqlsys/data/ -U postgres > /tmp/qstorpgdb.log 2>&1
if [ "$?" != "0" ]; then
 echo "Failed to initialize postgresql database! Check /tmp/qstorpgdb.log for more information"
 exit 1
fi

sctmpfile="/tmp/qstorinit.log"

$bindir/pg_ctl -w -D /quadstor/pgsqlsys/data/ -l $sctmpfile start >> /tmp/qstorpgdb.log 2>&1

sleep 5

$bindir/createdb qsdb >> /tmp/qstorpgdb.log 2>&1
if [ "$?" != "0" ]; then
 echo "Failed to create quadstor database! Check /tmp/qstorpgdb.log for more information"
 $bindir/pg_ctl -w -D /quadstor/pgsqlsys/data/ -l $sctmpfile stop >> /tmp/qstorpgdb.log 2>&1
 rm -f $sctmpfile
 exit 1
fi

psql -f /quadstor/pgsqlsys/share/qsdb.sql qsdb >> /tmp/qstorpgdb.log 2>&1

$bindir/pg_ctl -w -D /quadstor/pgsqlsys/data/ -l $sctmpfile stop >> /tmp/qstorpgdb.log 2>&1
sleep 5

exit 0
