#!/bin/sh
os=`uname`
/quadstor/pgsqlsys/etc/pgsql stop > /dev/null 2>&1

postgresconf="/quadstor/pgsqlsys/data/postgresql.conf"

grep -q "listen_addresses=''" $postgresconf
if [ "$?" != "0" -a -f $postgresconf ]; then
	echo "listen_addresses=''" >> $postgresconf
fi

/quadstor/pgsqlsys/etc/pgsql start > /dev/null 2>&1

if [ -x /sbin/runuser ]
then
    SU=/sbin/runuser
else
    SU=su
fi

rm -f /tmp/qstorpgdbpatch.log
export PGPORT=9984
if [ "$os" = "FreeBSD" ]; then
	su -l postgres -c 'psql -p 9984 -f /quadstor/pgsqlsys/share/qsdbpatch.sql qsdb >> /tmp/qstorpgdbpatch.log 2>&1'
else
	$SU -l postgres -c "psql -p 9984 -f /quadstor/pgsqlsys/share/qsdbpatch.sql qsdb >> /tmp/qstorpgdbpatch.log 2>&1"
fi

/quadstor/pgsqlsys/etc/pgsql stop > /dev/null 2>&1
