CREATE TABLE TDISK (
	TDISKID SERIAL UNIQUE,
	NAME VARCHAR(40) default NULL,
	DSIZE VARCHAR(16) default NULL,
	BLOCK VARCHAR(16) default NULL,
	DEDUPLICATION INT default 0,
	COMPRESSION INT default 0,
	VERIFY INT default 0,
	INLINE INT default 0,
	LBASHIFT INT default 0,
	DISABLED INT default 0
);

ALTER SEQUENCE tdisk_tdiskid_seq MAXVALUE 4096 MINVALUE 1 CYCLE;

CREATE TABLE PHYSSTOR (
	BID SERIAL UNIQUE,
	PID INT default NULL,
	TLID INT default NULL,
	VENDOR VARCHAR(8) default NULL,
	PRODUCT VARCHAR(16) default NULL,
	IDFLAGS BIGINT default NULL,
	T10ID bytea default NULL,
	NAAID bytea default NULL,
	EUI64ID bytea default NULL,
	UNKNOWNID bytea default NULL,
	ISRAID INT default NULL,
	RAIDDEV VARCHAR(512) default NULL,
	PRIMARY KEY (BID)
);

ALTER SEQUENCE physstor_bid_seq MAXVALUE 511 MINVALUE 1 CYCLE;

CREATE TABLE ISCSICONF (
	TDISKID INT default NULL,
	TARGETID INT default NULL,
	NOAUTH SMALLINT default NULL,
	UNAME VARCHAR(40) default NULL,
	PASSWD VARCHAR(40) default NULL,
	FOREIGN KEY (TDISKID) REFERENCES TDISK (TDISKID) ON DELETE CASCADE
);

CREATE TABLE SYSINFO (
	USERID VARCHAR(64),
	PASSWD VARCHAR(64),
	DCHECK INT default 0,
	SYS_RID  VARCHAR(40)
);
