ALTER TABLE ISCSICONF RENAME COLUMN UNAME TO INCOMINGUSER;
ALTER TABLE ISCSICONF RENAME COLUMN PASSWD TO INCOMINGPASSWD;
ALTER TABLE ISCSICONF DROP COLUMN NOAUTH;
ALTER TABLE ISCSICONF ADD COLUMN OUTGOINGUSER VARCHAR(40);
ALTER TABLE ISCSICONF ADD COLUMN OUTGOINGPASSWD VARCHAR(40);
ALTER TABLE ISCSICONF ADD COLUMN MAXCONNECTIONS INT default 1;
ALTER TABLE ISCSICONF ADD COLUMN MAXSESSIONS INT default 0;
ALTER TABLE ISCSICONF ADD COLUMN INITIALR2T INT default 0;
ALTER TABLE ISCSICONF ADD COLUMN MAXRECVDATASEGMENTLENGTH INT default 65536;
ALTER TABLE ISCSICONF ADD COLUMN MAXXMITDATASEGMENTLENGTH INT default 65536;
ALTER TABLE ISCSICONF ADD COLUMN MAXBURSTLENGTH INT default 262144;
ALTER TABLE ISCSICONF ADD COLUMN FIRSTBURSTLENGTH INT default 65536;
ALTER TABLE ISCSICONF ADD COLUMN NOPINTERVAL INT default 0;
ALTER TABLE ISCSICONF ADD COLUMN NOPTIMEOUT INT default 0;
ALTER TABLE ISCSICONF ADD COLUMN IQN VARCHAR(256);

CREATE TABLE STORAGEGROUP (
	NAME VARCHAR(40) default NULL,
	DEDUPEMETA INT default 0,
	LOGDATA INT default 0,
	GROUPID SERIAL UNIQUE
);

ALTER SEQUENCE storagegroup_groupid_seq MAXVALUE 255 MINVALUE 1 CYCLE;

ALTER TABLE TDISK ADD COLUMN GROUPID INT default 0;
ALTER TABLE PHYSSTOR ADD COLUMN GROUPID INT default 0;

CREATE TABLE MIRRORCHECK (
	MIRRORHOST VARCHAR(40) default NULL,
	CHECKTYPE INT default 0,
	CHECKVALUE VARCHAR(512) default NULL
);

CREATE TABLE FCCONFIG (
	WWPN VARCHAR(40) default NULL,
	TDISKID INT default NULL,
	RULE INT default 0
);

ALTER TABLE FCCONFIG ADD COLUMN WWPN1 VARCHAR(40) default NULL;
ALTER SEQUENCE tdisk_tdiskid_seq MAXVALUE 4095 MINVALUE 1 CYCLE;
ALTER TABLE TDISK ALTER COLUMN NAME TYPE VARCHAR(256);
ALTER TABLE TDISK ADD COLUMN LUNID INT default -1;
ALTER TABLE SYSINFO ADD COLUMN DALIGN INT default 0;
ALTER TABLE STORAGEGROUP ADD COLUMN DEDUPE INT default 1;
ALTER TABLE STORAGEGROUP ADD COLUMN DEDUPELITE INT default 0;

CREATE TABLE AUTHT (
	USR VARCHAR(64) default NULL,
	PASSWD VARCHAR(256) default NULL,
	RO INT default 0
);

ALTER TABLE FCCONFIG ADD COLUMN TARGETWWPN VARCHAR(40) default NULL;

CREATE TABLE FCHOST (
	HOST VARCHAR(256) default NULL,
	WWPN VARCHAR(40) default NULL
);

CREATE TABLE FCPORT (
	WWN VARCHAR(40) default NULL,
	WWPN VARCHAR(40) default NULL,
	PMODE INT default NULL
);

ALTER TABLE PHYSSTOR ADD COLUMN DISABLED INT default 0;
ALTER TABLE SYSINFO ADD COLUMN LASTBID INT default 0;
ALTER TABLE PHYSSTOR ADD COLUMN NAAIDLU bytea default NULL;
ALTER TABLE ISCSICONF ALTER COLUMN INCOMINGUSER SET DATA TYPE VARCHAR(256);
ALTER TABLE ISCSICONF ALTER COLUMN INCOMINGPASSWD SET DATA TYPE VARCHAR(256);
ALTER TABLE ISCSICONF ALTER COLUMN OUTGOINGUSER SET DATA TYPE VARCHAR(256);
ALTER TABLE ISCSICONF ALTER COLUMN OUTGOINGPASSWD SET DATA TYPE VARCHAR(256);
ALTER TABLE AUTHT ALTER COLUMN USR SET DATA TYPE VARCHAR(256);

CREATE TABLE ISCSICHAP (
	TLID INT default NULL,
	TARGETID INT default NULL,
	CHAPDIR INT default 0,
	CHAPUSER VARCHAR(256) default NULL,
	CHAPPASSWD VARCHAR(256) default NULL,
	CHAPIQN VARCHAR(256) default NULL,
	FOREIGN KEY (TLID) REFERENCES TDISK (TDISKID) ON DELETE CASCADE
);

