/* 
 * Copyright (C) Shivaram Upadhyayula <shivaram.u@quadstor.com>
 */

#ifndef QS_IOCTLDEFS_H_
#define QS_IOCTLDEFS_H_ 1

#include "commondefs.h"

struct msgblock {
	unsigned char block[512];
};

/* List of IOCTLS */
#define TL_MAGIC			'k'
#define FC_MAGIC			'K'

#define TLTARGIOCNEWBLKDEV		_IOWR(TL_MAGIC, 1, struct bdev_info)
#define TLTARGIOCDELBLKDEV		_IOWR(TL_MAGIC, 2, struct bdev_info)
#define TLTARGIOCGETBLKDEV		_IOWR(TL_MAGIC, 3, struct bdev_info)
#define TLTARGIOCDAEMONSETINFO		_IOWR(TL_MAGIC, 4, struct mdaemon_info)
#define TLTARGIOCCHECKDISKS		_IOWR(TL_MAGIC, 5, int)
#define TLTARGIOCLOADDONE		_IO(TL_MAGIC, 6) 
#define TLTARGIOCENABLEDEVICE		_IOWR(TL_MAGIC, 7, uint32_t)
#define TLTARGIOCDISABLEDEVICE		_IOWR(TL_MAGIC, 8, uint32_t)
#define TLTARGIOCNEWTDISK		_IOWR(TL_MAGIC, 9, struct tdisk_info)
#define TLTARGIOCLOADTDISK		_IOWR(TL_MAGIC, 10, struct tdisk_info)
#define TLTARGIOCDELETETDISK		_IOWR(TL_MAGIC, 11, struct tdisk_info)
#define TLTARGIOCATTACHTDISK		_IOWR(TL_MAGIC, 12, struct tdisk_info)
#define TLTARGIOCMODIFYTDISK		_IOWR(TL_MAGIC, 13, struct tdisk_info)
#define TLTARGIOCTDISKSTATS		_IOWR(TL_MAGIC, 14, struct tdisk_info) 
#define TLTARGIOCTDISKRESETSTATS	_IOWR(TL_MAGIC, 15, struct tdisk_info)
#define TLTARGIOCBINTRESETSTATS		_IOWR(TL_MAGIC, 16, uint32_t)
#define TLTARGIOCRESETLOGS		_IO(TL_MAGIC, 17) 
#define TLTARGIOCUNLOAD			_IO(TL_MAGIC, 18) 
#define TLTARGIOCNODECONFIG		_IOWR(TL_MAGIC, 19, struct node_config) 
#define TLTARGIOCNEWBDEVSTUB		_IOWR(TL_MAGIC, 20, struct bdev_info) 
#define TLTARGIOCDELETEBDEVSTUB		_IOWR(TL_MAGIC, 21, struct bdev_info) 
#define TLTARGIOCNEWTDISKSTUB		_IOWR(TL_MAGIC, 22, struct tdisk_info)
#define TLTARGIOCDELETETDISKSTUB	_IOWR(TL_MAGIC, 23, struct tdisk_info)
#define TLTARGIOCCLONEVDISK		_IOWR(TL_MAGIC, 24, struct clone_config)
#define TLTARGIOCCLONESTATUS		_IOWR(TL_MAGIC, 25, struct clone_config)
#define TLTARGIOCCLONECANCEL		_IOWR(TL_MAGIC, 26, struct clone_config)
#define TLTARGIOCMIRRORVDISK		_IOWR(TL_MAGIC, 27, struct clone_config)
#define TLTARGIOCMIRRORSTATUS		_IOWR(TL_MAGIC, 28, struct clone_config)
#define TLTARGIOCMIRRORCANCEL		_IOWR(TL_MAGIC, 29, struct clone_config)
#define TLTARGIOCDISABLETDISKSTUB	_IOWR(TL_MAGIC, 30, struct tdisk_info)
#define TLTARGIOCRESIZETDISK		_IOWR(TL_MAGIC, 31, struct tdisk_info)
#define TLTARGIOCADDGROUP		_IOWR(TL_MAGIC, 32, struct group_conf)
#define TLTARGIOCDELETEGROUP		_IOWR(TL_MAGIC, 33, struct group_conf)
#define TLTARGIOCHACONFIG		_IOWR(TL_MAGIC, 34, struct bdev_info)
#define TLTARGIOCNODESTATUS		_IOWR(TL_MAGIC, 35, struct node_config) 
#define TLTARGIOCMIRRORREMOVE		_IOWR(TL_MAGIC, 36, struct clone_config)
#define TLTARGIOCADDFCRULE		_IOWR(TL_MAGIC, 37, struct fc_rule_config)
#define TLTARGIOCREMOVEFCRULE		_IOWR(TL_MAGIC, 38, struct fc_rule_config)
#define TLTARGIOCDELETETDISKPOST	_IOWR(TL_MAGIC, 39, struct tdisk_info)
#define TLTARGIOCUNMAPCONFIG		_IOWR(TL_MAGIC, 40, struct bdev_info)
#define TLTARGIOCRENAMEGROUP		_IOWR(TL_MAGIC, 41, struct group_conf)
#define TLTARGIOCRENAMETDISK		_IOWR(TL_MAGIC, 42, struct tdisk_info)
#define TLTARGIOCSETMIRRORROLE		_IOWR(TL_MAGIC, 44, struct tdisk_info)
#define TLTARGIOCDDTABLELOADSTATUS	_IO(TL_MAGIC, 45) 
#define TLTARGIOCQLOADDONE		_IO(TL_MAGIC, 46) 
#define TLTARGIOCSTARTUNMAP		_IOWR(TL_MAGIC, 47, struct bdev_info)
#define TLTARGIOCSTOPUNMAP		_IOWR(TL_MAGIC, 48, struct bdev_info)
#define TLTARGIOCDDTABLEALIGN		_IO(TL_MAGIC, 49)
#define TLTARGIOCMODIFYFCRULE		_IOWR(TL_MAGIC, 50, struct fc_rule_config)
#define TLTARGIOCMODBLKDEV		_IOWR(TL_MAGIC, 73, struct bdev_info)
#define TLTARGIOCLDEVNEW		_IOWR(TL_MAGIC, 75, struct ldev_info)
#define TLTARGIOCLDEVDISABLE		_IOWR(TL_MAGIC, 76, struct ldev_info)
#define TLTARGIOCLDEVDELETE		_IOWR(TL_MAGIC, 77, struct ldev_info)
#define TLTARGIOCLDEVUPDATE		_IOWR(TL_MAGIC, 78, struct ldev_info)
#define TLTARGIOCLDEVINIT		_IO(TL_MAGIC, 79) 
#define TLTARGIOCLDEVBIOREQ		_IOW(TL_MAGIC, 80, struct bio_spec)
#define TLTARGIOCLDEVBDEVOPEN		_IOWR(TL_MAGIC, 81, struct bdev_spec)
#define TLTARGIOCLDEVBDEVCLOSE		_IOWR(TL_MAGIC, 82, struct bdev_spec)
#define TLTARGIOCCTIOMMAPSETUP		_IOWR(TL_MAGIC, 83, struct ctio_mmap_setup)
#define TLTARGIOCCTIOWAKEUP		_IOW(TL_MAGIC, 84, struct ctio_wakeup)
#define TLTARGIOCCOMPUNCOMP		_IOW(TL_MAGIC, 85, struct comp_spec)
#define TLTARGIOCLDEVDETACH		_IO(TL_MAGIC, 86) 
#define TLTARGIOCLDEVBDEVSYNC		_IOW(TL_MAGIC, 87, struct bdev_sync)
#define TLTARGIOCBIOMSGMMAPSETUP	_IOWR(TL_MAGIC, 92, struct bio_mmap_setup)
#define TLTARGIOCBIOMSGMMAPEXIT		_IO(TL_MAGIC, 93)
#define TLTARGIOCCOREDEVLOADDONE	_IO(TL_MAGIC, 94)
#define TLTARGIOCLDEVBDEVVALIDATE	_IOWR(TL_MAGIC, 95, struct bdev_spec)
#define TLTARGIOCLDEVCTIOSETUP		_IOWR(TL_MAGIC, 96, struct ctio_spec)
#define TLTARGIOCLDEVTDEVOPEN		_IOWR(TL_MAGIC, 97, struct bdev_spec)
#define TLTARGIOCLDEVTDEVCLOSE		_IOWR(TL_MAGIC, 98, struct bdev_spec)
#define TLTARGIOCLDEVSOCKCREATE		_IOWR(TL_MAGIC, 99, struct sock_spec)
#define TLTARGIOCLDEVSOCKCREATELOCAL	_IOWR(TL_MAGIC, 100, struct sock_spec)
#define TLTARGIOCLDEVSOCKCONNECT	_IOWR(TL_MAGIC, 101, struct sock_spec)
#define TLTARGIOCLDEVSOCKCONNECTLOCAL	_IOWR(TL_MAGIC, 102, struct sock_spec)
#define TLTARGIOCLDEVSOCKREAD		_IOWR(TL_MAGIC, 103, struct sock_data_spec)
#define TLTARGIOCLDEVSOCKWRITE		_IOWR(TL_MAGIC, 104, struct sock_data_spec)
#define TLTARGIOCLDEVSOCKSHUTDOWN	_IOWR(TL_MAGIC, 105, struct sock_spec)
#define TLTARGIOCLDEVSOCKCLOSE		_IOWR(TL_MAGIC, 106, struct sock_spec)
#define TLTARGIOCLDEVSOCKACCEPT		_IOWR(TL_MAGIC, 107, struct sock_spec)
#define TLTARGIOCLDEVSOCKBIND		_IOWR(TL_MAGIC, 108, struct sock_spec)
#define TLTARGIOCLDEVSOCKHASWRITESPACE	_IOWR(TL_MAGIC, 109, struct sock_spec)
#define TLTARGIOCLDEVSOCKISCONNECTED	_IOWR(TL_MAGIC, 110, struct sock_spec)
#define TLTARGIOCLDEVSOCKPOLL		_IOWR(TL_MAGIC, 111, struct sock_spec)
#define TLTARGIOCLDEVSOCKHASREADDATA	_IOWR(TL_MAGIC, 112, struct sock_spec)
#define TLTARGIOCLDEVSOCKNOPUSH		_IOWR(TL_MAGIC, 113, struct sock_spec)
#define TLTARGIOCUMAINFO		_IOWR(TL_MAGIC, 114, struct uma_spec)
#define TLTARGIOCLDEVBIOUNMAP		_IOW(TL_MAGIC, 117, struct bio_spec)
#define TLTARGIOCLDEVBDEVUNMAPSUPPORT	_IOW(TL_MAGIC, 118, struct bio_spec)

#define FCTARGIOCENABLEHBA		_IOWR(FC_MAGIC, 181, struct hba_info)
#define FCTARGIOCHBADEBUG		_IOWR(FC_MAGIC, 182, struct hba_info)
#endif
