#ifndef QUADSTOR_DEVQ_H_
#define QUADSTOR_DEVQ_H_

#ifdef FREEBSD 
#include "bsddefs.h"
#else
#include "linuxdefs.h"
#endif
#include "exportdefs.h"

struct qs_devq {
	struct qsio_hdr *(*next_ccb) (struct qs_devq *);
	struct ccb_list pending_queue;
	wait_chan_t devq_wait;
	kproc_t *task;
	void (*proc_cmd)(struct qsio_scsiio *);
	int flags;
	mtx_t devq_lock;
};

struct qs_devq * devq_init(uint32_t base_id, const char *name, void (*proc_cmd) (struct qsio_scsiio *));
void devq_exit(struct qs_devq *devq);

#define DEVQ_SHUTDOWN		0x02

static inline void
devq_insert_ccb(struct qs_devq *devq, struct qsio_hdr *ccb_h)
{
#ifdef LINUX
	unsigned long flags;
#endif

	mtx_lock_irqsave(&devq->devq_lock, flags);
	STAILQ_INSERT_TAIL(&devq->pending_queue, ccb_h, c_list);
	mtx_unlock_irqrestore(&devq->devq_lock, flags);
	chan_wakeup_one(&devq->devq_wait);
	return;
}

#endif
