#ifndef QLA_QDEFS_H_
#define QLA_QDEFS_H_

#include <linux/version.h>
#include <linux/pci.h>

#ifndef MIN_NICE
#define MIN_NICE	-20
#endif

#ifndef fallthrough
# define fallthrough			do {} while (0)  /* fallthrough */
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(5, 2, 0) && (!defined(RHEL_MAJOR) || RHEL_MAJOR < 8)
#define ELS_FPIN	0x16
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(5, 10, 0) && (!defined(RHEL_MAJOR) || RHEL_MAJOR < 8)
#define ELS_RDP		0x18
#endif

#if ((LINUX_VERSION_CODE >= KERNEL_VERSION(4, 12, 0)) || (defined(CONFIG_SUSE_KERNEL) && LINUX_VERSION_CODE >= KERNEL_VERSION(4, 4, 73)))
typedef struct bsg_job bsg_job_t;
#else
typedef struct fc_bsg_job bsg_job_t;
static inline struct Scsi_Host *fc_bsg_to_shost(bsg_job_t *job)
{
	return job->shost;
}
static inline struct fc_rport *fc_bsg_to_rport(bsg_job_t *job)
{
	return job->rport;
}
#endif

#ifndef T10_PI_APP_ESCAPE
#define T10_PI_APP_ESCAPE cpu_to_be16(0xffff)
#endif

#ifndef T10_PI_REF_ESCAPE
#define T10_PI_REF_ESCAPE cpu_to_be32(0xffffffff)
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(4, 0, 0)
struct t10_pi_tuple {
	__be16 guard_tag;       /* Checksum */
	__be16 app_tag;         /* Opaque storage */
	__be32 ref_tag;         /* Target LBA or indirect LBA */
};
#define ktime_get_real_seconds	get_seconds
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(5, 8, 0) && (!defined(RHEL_MAJOR) || RHEL_MAJOR < 8)
static inline int
trace_ql_dbg_log_enabled(void)
{
	return 0;
}
#define trace_ql_dbg_log(p,x)	pr_warn("%s%pV", p, x)
#endif

#if LINUX_VERSION_CODE >= KERNEL_VERSION(5, 14, 0)
#define set_driver_byte(cm, sn) do {} while(0)
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(5, 14, 0) && (!defined(RHEL_MAJOR) || RHEL_MAJOR < 8 || (RHEL_MAJOR == 8 && (RHEL_RELEASE_CODE < 2055)))
#include <scsi/scsi_eh.h>
static inline struct request *
__scsi_cmd_to_rq(struct scsi_cmnd *cmd)
{
	return cmd->request;
}
#else
#define __scsi_cmd_to_rq	scsi_cmd_to_rq
#endif
#if LINUX_VERSION_CODE < KERNEL_VERSION(5, 14, 0) && (!defined(RHEL_MAJOR) || RHEL_MAJOR < 8 || (RHEL_MAJOR == 8 && (RHEL_RELEASE_CODE < 2065)))
static inline void scsi_build_sense(struct scsi_cmnd *scmd, int desc, u8 key, u8 asc, u8 ascq)
{
	scsi_build_sense_buffer(desc, scmd->sense_buffer, key, asc, ascq);
	scmd->result = SAM_STAT_CHECK_CONDITION;
}

#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(5, 2, 0) && (!defined(RHEL_MAJOR) || RHEL_MAJOR < 8)
static inline int list_is_first(const struct list_head *list, const struct list_head *head)
{
	return list->prev == head;
}
#endif

#endif
