#ifndef QLA_QDEFS_H_
#define QLA_QDEFS_H_

#include <linux/version.h>

#if LINUX_VERSION_CODE < KERNEL_VERSION(5, 14, 0) && (!defined(RHEL_MAJOR) || RHEL_MAJOR < 9)
#define scsi_done(cmdxx)	cmdxx->scsi_done(cmdxx)
#endif
#if LINUX_VERSION_CODE < KERNEL_VERSION(6, 6, 0) && (!defined(RHEL_MAJOR) || RHEL_MAJOR < 8)
#define timer_shutdown		del_timer
#endif


#if LINUX_VERSION_CODE < KERNEL_VERSION(5, 14, 0) && (!defined(RHEL_MAJOR) || RHEL_MAJOR < 8 || (RHEL_MAJOR == 8 && (RHEL_RELEASE_CODE < 2055)))
#include <scsi/scsi_eh.h>
static inline struct request *
__scsi_cmd_to_rq(struct scsi_cmnd *cmd)
{
	return cmd->request;
}
#else
#define __scsi_cmd_to_rq	scsi_cmd_to_rq
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(5, 14, 0) && (!defined(RHEL_MAJOR) || RHEL_MAJOR < 8 || (RHEL_MAJOR == 8 && (RHEL_RELEASE_CODE < 2065)))
static inline void scsi_build_sense(struct scsi_cmnd *scmd, int desc, u8 key, u8 asc, u8 ascq)
{
	scsi_build_sense_buffer(desc, scmd->sense_buffer, key, asc, ascq);
	scmd->result = SAM_STAT_CHECK_CONDITION;
}
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(5, 14, 0)
#define vmalloc_array(nm,sz)	vmalloc(nm * sz)
#endif

#ifndef DECLARE_FLEX_ARRAY
#define DECLARE_FLEX_ARRAY(TYPE, NAME)        \
	struct { \
		struct { } __empty_ ## NAME; \
		TYPE NAME[]; \
	}
#endif

#endif
